﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ConsoleGeneric
{
    public abstract class Calc<T>
    {
        public abstract T Add(T a, T b);
        public abstract T Sub(T a, T b);
        public abstract T Mult(T a, T b);
        public abstract T Div(T a, T b);
    }
    public class IntCalc : Calc<int>
    {
        public override int Add(int a, int b) { return (a + b); }
        public override int Sub(int a, int b) { return (a - b); }
        public override int Mult(int a, int b) { return (a * b); }
        public override int Div(int a, int b) { return (a / b); }
    }
    public class DoubleCalc : Calc<double>
    {
        public override double Add(double a, double b) { return (a + b); }
        public override double Sub(double a, double b) { return (a - b); }
        public override double Mult(double a, double b) { return (a * b); }
        public override double Div(double a, double b) { return (a / b); }
    }
    public class StringCalc : Calc<string>
    {
        public override string Add(string a, string b) { return (a + b); }
        public override string Sub(string a, string b) { return (a); }
        public override string Mult(string a, string b) { return (a); }
        public override string Div(string a, string b) { return (a); }
    }

}
