﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ConsoleGeneric
{
    /// <summary>
    /// Элемент односвязного списка
    /// содержит два поля - информационное и ссылку    
    /// </summary>
    /// <typeparam name="T">тип элементов, хранимых в списке</typeparam>
    public class GenLinkable<T>
    {
        /// <summary>
        /// Информационное поле - объект типа T
        /// </summary>
        public T Item;

        /// <summary>
        /// Ссылка на следующий элемент списка
        /// </summary>
        public GenLinkable<T> Next;

        /// <summary>
        /// Конструктор без аргументов
        /// Инициализиует поля значениями по умолчанию
        /// </summary>
        public GenLinkable()
        { Item = default(T); Next = null; }
    }

}
