﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ConsoleGeneric
{
    /// <summary>
    /// Стек, построенный на односвязных элементах списка GenLinkable{T}
    /// </summary>
    public class OneLinkStack<T> : GenStack<T>
    {
        /// <summary>
        /// ссылка на стек (вершину стека)
        /// </summary>
        GenLinkable<T> last;
        /// <summary>
        /// Конструктор без аргументов
        /// </summary>
        public OneLinkStack()
        {
            last = null;
        }

        /**
         * <remarks>Реализация методов абстрактного класса</remarks>
         * */
        /// <summary>
        /// require: not empty();
        /// </summary>
        /// <returns>элемент вершины(последний пришедший)</returns>
        public override T item()
        {
            return (last.Item);
        }//item		
        /// <summary>
        /// require: true;
        /// </summary>
        /// <returns>true если стек пуст, иначе false </returns>
        public override bool empty()
        {
            return (last == null);
        }//empty		
        /// <summary>
        /// require: true; ensure: elem находится в вершине стека
        /// </summary>
        /// <param name="elem"></param>
        public override void put(T elem)
        {
            GenLinkable<T> newitem = new GenLinkable<T>();
            newitem.Item = elem; newitem.Next = last;
            last = newitem;
        }//put 		
        /// <summary>
        /// require: not empty();
        /// ensure: удален элемент вершины(последний пришедший)
        /// </summary>
        public override void remove()
        {
            last = last.Next;
        }//remove
    }//class OneLinkStack

}
