﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ConsoleGeneric
{
    public class SumList<K, T> : OneLinkList<K, T> where K : IComparable<K>
    {
        Calc<T> calc;
        T sum;
        public SumList(Calc<T> calc)
        { this.calc = calc; sum = default(T); }

        public new void add(K key, T item)
        {
            Node<K, T> newnode = new Node<K, T>();
            if (first == null)
            {
                first = newnode; cursor = newnode;
                newnode.key = key; newnode.item = item;
                sum = calc.Add(sum, item);
            }
            else
            {
                newnode.next = cursor.next; cursor.next = newnode;
                newnode.key = key; newnode.item = item;
                sum = calc.Add(sum, item);
            }
        }
        public T Sum()
        { return (sum); }
    }//SumList

}
