using System;
using System.Collections.Generic;
using System.Text;

namespace ConsoleGeneric
{
    /// <summary>
    ///   GenStack{T}     LIFO:	
    /// :
    ///  new: -> GenStack{T}
    /// :
    /// item: GenStack -> T
    /// empty: GenStack -> Boolean
    /// :
    /// put: GenStack*T -> GenStack
    /// remove: GenStack -> GenStack
    /// :
    /// remove(put(s,x)) = s
    /// item(put(s,x)) = x
    /// empty(new)= true
    /// empty(put(s,x)) = false
    /// </summary>    
    abstract public class GenStack<T>
    {
        /// <summary>
        /// require: not empty();
        /// </summary>
        /// <returns> ( )</returns>
        abstract public T item();

        /// <summary>
        /// require: not empty();
        /// ensure:   ( )
        /// </summary>
        abstract public void remove();

        /// <summary>
        /// require: true; ensure: elem    
        /// </summary>
        /// <param name="elem"></param>
        abstract public void put(T elem);

        /// <summary>
        /// require: true;
        /// </summary>
        /// <returns>true   ,  false </returns>
        abstract public bool empty();
    }// class GenStack
}
