using System;
using System.Collections.Generic;
using System.Text;
using ConsoleInterface;
using IntStack = ConsoleGeneric.OneLinkStack<int>;

namespace ConsoleGeneric
{
    class Testing
    {
        Generic gen = new Generic();
        public void TestSwapT()
        {
            int n1 = 7, n2 = 11;
            double x1 = 7.7, x2 = 11.1;
            Console.WriteLine("n1 = {0}, n2 = {1}", n1, n2);
            Console.WriteLine("x1 = {0}, x2 = {1}", x1, x2);

            Console.WriteLine("    ");
            gen.Swap<int>(ref n1, ref n2);
            gen.Swap<double>(ref x1, ref x2);
            Console.WriteLine("n1 = {0}, n2 = {1}", n1, n2);
            Console.WriteLine("x1 = {0}, x2 = {1}", x1, x2);

            Console.WriteLine("    ");
            //gen.Swap<int>(ref n1, ref x1);
            //gen.Swap<double>(ref x1, ref n1);
            Console.WriteLine("     !");
        }
        public void TestSwapObject()
        {
            int n1 = 7, n2 = 11;
            double x1 = 7.7, x2 = 11.1;
            Console.WriteLine("n1 = {0}, n2 = {1}", n1, n2);
            Console.WriteLine("x1 = {0}, x2 = {1}", x1, x2);

            Console.WriteLine("     ");
           // gen.SwapObject(ref n1, ref n2);
           // gen.SwapObject(ref x1, ref x2);
            Console.WriteLine("     !");
            Console.WriteLine("    ! ");
            object obj1, obj2;
            obj1 = n1; obj2 = n2;
            gen.SwapObject(ref obj1, ref obj2);
            n1 = (int)obj1; n2 = (int)obj2;
            Console.WriteLine("n1 = {0}, n2 = {1}", n1, n2);
            obj1 = x1; obj2 = x2;
            gen.SwapObject(ref obj1, ref obj2);
            x1 = (double)obj1; x2 = (double)obj2;
            Console.WriteLine("x1 = {0}, x2 = {1}", x1, x2);

            Console.WriteLine("   ");
            obj1 = n1; obj2 = x1;
            gen.SwapObject(ref obj1, ref obj2);
            Console.WriteLine("    !");
            //n1 = (int)obj1; x1 = (double)obj2;
            //Console.WriteLine("n1 = {0}, x1 = {1}", n1, x1);
        }
        public void TestStacks()
        {
            OneLinkStack<int> stack1 = new OneLinkStack<int>();
            OneLinkStack<string> stack2 = new OneLinkStack<string>();
            ArrayUpStack<double> stack3 = new ArrayUpStack<double>(10);

            stack1.put(11); stack1.put(22);
            int x1 = stack1.item(), x2 = stack1.item();
            if ((x1 == x2) && (x1 == 22)) Console.WriteLine("OK!");
            stack1.remove(); x2 = stack1.item();
            if ((x1 != x2) && (x2 == 11)) Console.WriteLine("OK!");
            stack1.remove(); x2 = (stack1.empty()) ? 77 : stack1.item();
            if ((x1 != x2) && (x2 == 77)) Console.WriteLine("OK!");

            stack2.put("first"); stack2.put("second");
            stack2.remove(); string s = stack2.item();
            if (!stack2.empty()) Console.WriteLine(s);

            stack3.put(3.33); stack3.put(Math.Sqrt(Math.PI));
            double res = stack3.item();
            stack3.remove(); res += stack3.item();
            Console.WriteLine("res= {0}", res);
        }
        public void TestPerson()
        {
            OneLinkStack<int> stack1 = new OneLinkStack<int>();
            OneLinkStack<string> stack2 = new OneLinkStack<string>();
            ArrayUpStack<double> stack3 = new ArrayUpStack<double>(10);
            ArrayUpStack<Person> stack4 = new ArrayUpStack<Person>(7);

            stack2.put(""); stack2.put(""); stack2.put("");
            stack1.put(27); stack1.put(45); stack1.put(53);
            stack3.put(21550.5); stack3.put(12345.7); stack3.put(32458.8);

            stack4.put(new Person(stack2.item(), stack1.item(), stack3.item()));
            stack1.remove(); stack2.remove(); stack3.remove();
            stack4.put(new Person(stack2.item(), stack1.item(), stack3.item()));
            stack1.remove(); stack2.remove(); stack3.remove();
            stack4.put(new Person(stack2.item(), stack1.item(), stack3.item()));

            Person pers = stack4.item(); pers.PrintPerson();
            stack4.remove(); pers = stack4.item(); pers.PrintPerson();
            stack4.remove(); pers = stack4.item(); pers.PrintPerson();
            stack4.remove(); if (stack4.empty()) Console.WriteLine("OK!");
        }
        public void TestConstraint()
        {
            OneLinkList<int, string> list1 = new OneLinkList<int, string>();
            list1.add(33, "thirty three"); list1.add(22, "twenty two");
            if (list1.findstart(33)) Console.WriteLine("33 - !");
            else Console.WriteLine("33 -  !");
            if (list1.findstart(22)) Console.WriteLine("22 - !");
            else Console.WriteLine("22 -  !");
            if (list1.findstart(44)) Console.WriteLine("44 - !");
            else Console.WriteLine("44 -  !");
            Person pers1 = new Person("", 25, 1500);
            Person pers2 = new Person("", 35, 2100);
            OneLinkList<string, Person> list2 = new OneLinkList<string, Person>();
            list2.add("", pers1); list2.add("", pers2);
            if (list2.findstart("")) Console.WriteLine(" - !");
            else Console.WriteLine(" -  !");
            if (list2.findstart("")) Console.WriteLine(" - !");
            else Console.WriteLine(" -  !");
            if (list2.findstart("")) Console.WriteLine(" - !");
            else Console.WriteLine(" -  !");
            Person pers3 = new Person("", 33, 3000);
            list2.add("", pers3); list2.start();
            Person pers = list2.Item(); pers.PrintPerson();
            list2.findstart(""); pers = list2.Item(); pers.PrintPerson();
        }
        public void TestSum()
        {
            SumList<string, int> list1 = 
                new SumList<string, int>(new IntCalc());
            list1.add("", 33); list1.add("", 44);
            Console.WriteLine("sum= {0}", list1.Sum());
            SumList<string, double> list2 = 
                new SumList<string, double>(new DoubleCalc());
            list2.add("", 33.33); list2.add("", 44.44);
            Console.WriteLine("sum= {0}", list2.Sum());
            SumList<string, string> list3 = 
                new SumList<string, string>(new StringCalc());
            list3.add("", "   "); 
            list3.add("", " !");
            Console.WriteLine("sum= {0}", list3.Sum());
        }
        public void TestSpace()
        {
            Spaceship spaceship = new Spaceship();
            Home_Spaceship home_ship = 
                new Home_Spaceship(spaceship);
            Console.WriteLine("  !");
        }

        public void TestIntStack()
        {
            IntStack stack1 = new IntStack();
            IntStack stack2 = new IntStack();
            IntStack stack3 = new IntStack();

            stack1.put(11); stack1.put(22);
            int x1 = stack1.item(), x2 = stack1.item();
            if ((x1 == x2) && (x1 == 22)) Console.WriteLine("OK!");
            stack1.remove(); x2 = stack1.item();
            if ((x1 != x2) && (x2 == 11)) Console.WriteLine("OK!");
            stack1.remove(); x2 = (stack1.empty()) ? 77 : stack1.item();
            if ((x1 != x2) && (x2 == 77)) Console.WriteLine("OK!");

            stack2.put(55); stack2.put(66);
            stack2.remove(); int s = stack2.item();
            if (!stack2.empty()) Console.WriteLine(s);

            stack3.put(333); stack3.put((int)Math.Sqrt(Math.PI));
            int res = stack3.item();
            stack3.remove(); res += stack3.item();
            Console.WriteLine("res= {0}", res);
        }
        public int max2(int a, int b)
        { return (a > b) ? a : b; }
        public double min2(double a, double b)
        { return (a < b) ? a : b; }
        public string sum2(string a, string b)
        { return a + b; }
        public float prod2(float a, float b)
        { return a * b; }
        public void TestFun()
        {
            int[] ar1 = { 3, 5, 7, 9 };
            double[] ar2 = { 3.5, 5.7, 7.9 };
            string[] ar3 = { " ", " ", " ", "." };
            float[] ar4 = { 5f, 7f, 9f, 11f };
            UniversalDelegates<int> d1 = 
                new UniversalDelegates<int>();
            UniversalDelegates<int>.Unidel del1;
            del1 = this.max2;
            int max = d1.FunAr(ar1, ar1[0], del1);
            Console.WriteLine("max= {0}", max);

            UniversalDelegates<double> d2 = 
                new UniversalDelegates<double>();
            UniversalDelegates<double>.Unidel del2;
            del2 = this.min2;
            double min = d2.FunAr(ar2, ar2[0], del2);
            Console.WriteLine("min= {0}", min);

            UniversalDelegates<string> d3 = 
                new UniversalDelegates<string>();
            UniversalDelegates<string>.Unidel del3;
            del3 = this.sum2;
            string sum = d3.FunAr(ar3, "", del3);
            Console.WriteLine("concat= {0}", sum);

            UniversalDelegates<float> d4 = 
                new UniversalDelegates<float>();
            UniversalDelegates<float>.Unidel del4;
            del4 = this.prod2;
            float prod = d4.FunAr(ar4, 1f, del4);
            Console.WriteLine("prod= {0}", prod);
        }
        public void TestLanbdaFun()
        {
            int[] ar1 = { 3, 5, 7, 9 };
            double[] ar2 = { 3.5, 5.7, 7.9 };
            string[] ar3 = { " ", " ", " ", "." };
            float[] ar4 = { 5f, 7f, 9f, 11f };
            UniversalDelegates<int> d1 =
                new UniversalDelegates<int>();
            UniversalDelegates<int>.Unidel del1;
            del1 = max2;
            int max = d1.FunAr(ar1, ar1[0], 
                del1);
            Console.WriteLine("max= {0}", max);

            UniversalDelegates<double> d2 =
                new UniversalDelegates<double>();
            UniversalDelegates<double>.Unidel del2;
            del2 = this.min2;
            double min = d2.FunAr(ar2, ar2[0], del2);
            Console.WriteLine("min= {0}", min);

            UniversalDelegates<string> d3 =
                new UniversalDelegates<string>();
            UniversalDelegates<string>.Unidel del3;
            del3 = this.sum2;
            string sum = d3.FunAr(ar3, "", del3);
            Console.WriteLine("concat= {0}", sum);

            UniversalDelegates<float> d4 =
                new UniversalDelegates<float>();
            UniversalDelegates<float>.Unidel del4;
            del4 = this.prod2;
            float prod = d4.FunAr(ar4, 1f, del4);
            Console.WriteLine("prod= {0}", prod);
        }


    }
}
